diff --git a/build.gradle.kts b/build.gradle.kts
index 6afe1dc86..9b61f98b1 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -26,22 +26,3 @@ ext["lwjglNatives"] = Pair(
             throw Error("Unrecognized or unsupported platform. Please set \"lwjglNatives\" manually")
     }
 }
-
-plugins {
-    id("java")
-}
-
-
-
-val genJavadoc by tasks.registering(Javadoc::class) {
-    val exposedProjects = listOf(
-        ":game:core",
-        ":game:client",
-        ":game:server",
-    )
-    val sourceSets = exposedProjects.map { project(it).sourceSets["main"] }
-    classpath = files(sourceSets.map { it.compileClasspath })
-    setSource(exposedProjects.map { project(it).sourceSets["main"].allJava })
-    setDestinationDir(file("${layout.buildDirectory.get()}/docs/javadoc"))
-    print(destinationDir)
-}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java b/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
index ee424dc59..bba31dcd5 100644
--- a/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
@@ -22,8 +22,9 @@ import net.minecraft.core.world.pos.ChunkTilePos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveFormatBase;
-import net.minecraft.client.world.save.SaveHandlerClientMP;
+import net.minecraft.core.world.save.LevelStorageDummy;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
+import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 import org.jetbrains.annotations.NotNull;
@@ -493,12 +494,12 @@ public class BiomeFinder implements MinecraftAccessor {
 		BiomeProvider biomeProvider;
 		World world;
 		if (worldFolder == null){
-			biomeProvider = worldType.createBiomeProvider(new World(new SaveHandlerClientMP(), "", dimension, worldType, seed));
+			biomeProvider = worldType.createBiomeProvider(new World(new SavedDataStorage(new LevelStorageDummy()), "", seed, dimension, worldType));
 			world = null;
 		} else {
 			SaveFormatBase saveFormat = new SaveFormat19134(worldFolder.getParentFile());
-			LevelStorage saveHandler = saveFormat.getSaveHandler(worldFolder.getName(), false);
-			world = new World(saveHandler, saveHandler.getLevelData().getWorldName(), saveHandler.getLevelData().getRandomSeed(), null, null, null);
+			LevelStorage saveHandler = saveFormat.getLevelStorage(worldFolder.getName(), false);
+			world = new World(saveHandler, saveHandler.getLevelData().getWorldName(), saveHandler.getLevelData().getRandomSeed(), Dimension.OVERWORLD, null);
 			biomeProvider = worldType.createBiomeProvider(world);
 		}
 		allBiomes.clear();
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 433dc9acd..5be459f2d 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -98,7 +98,7 @@ import net.minecraft.client.world.WorldClientMP;
 import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
 import net.minecraft.client.world.chunk.provider.ChunkProviderThreadedClient;
-import net.minecraft.client.world.save.SaveHandlerClientSP;
+import net.minecraft.client.world.save.LevelStorageClientSP;
 import net.minecraft.core.Global;
 import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.MinecraftError;
@@ -157,6 +157,7 @@ import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.player.Session;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.gamemode.Gamemodes;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.util.debug.Debug;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Color;
@@ -235,7 +236,7 @@ public class Minecraft
     public boolean hasCrashed;
     public UnexpectedThrowable lastCrash;
     public final Timer timer;
-    public WorldClient currentWorld;
+    public @Nullable WorldClient currentWorld;
     public RenderGlobal renderGlobal;
     public PlayerLocal thePlayer;
     public ICamera activeCamera;
@@ -516,7 +517,7 @@ public class Minecraft
         this.resolution.setScale(GameSettings.GUI_SCALE.value);
 
         SaveFormatBase handlerBase = new SaveFormat19134(new File(this.mcDataDir, "saves"));
-        handlerBase.factory = SaveHandlerClientSP::new;
+        handlerBase.factory = LevelStorageClientSP::new;
         this.saveFormat = handlerBase;
         I18n.initialize(GameSettings.LANGUAGE.value);
 
@@ -1799,10 +1800,10 @@ public class Minecraft
         if (GameSettings.KEY_HOT_BAR_SWITCH.isPressEvent(currentInputDevice)) {
             if (!this.thePlayer.inventory.currentSlotLocked()) {
                 if (shift) {
-                    this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + 27) % (36));
+                    this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE)) % ContainerInventory.MAIN_INVENTORY_SIZE);
                     this.hotbarSwapAnimationProgress = -HOTBAR_SWAP_ANIMATION_LENGTH_TICKS;
                 } else {
-                    this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + 9) % (36));
+                    this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + ContainerInventory.HOTBAR_SIZE) % ContainerInventory.MAIN_INVENTORY_SIZE);
                     this.hotbarSwapAnimationProgress = HOTBAR_SWAP_ANIMATION_LENGTH_TICKS;
                 }
                 this.thePlayer.inventory.changeCurrentSlot(0);
@@ -1987,14 +1988,14 @@ public class Minecraft
             }
             if (controller.digitalPad.up.pressedThisFrame()) {
                 if (!this.thePlayer.inventory.currentSlotLocked()) {
-                    this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + 27) % (36));
+                    this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE)) % ContainerInventory.MAIN_INVENTORY_SIZE);
                     this.hotbarSwapAnimationProgress = -HOTBAR_SWAP_ANIMATION_LENGTH_TICKS;
                     this.thePlayer.inventory.changeCurrentSlot(0);
                 }
             }
             if (controller.digitalPad.down.pressedThisFrame()) {
                 if (!this.thePlayer.inventory.currentSlotLocked()) {
-                    this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + 9) % (36));
+                    this.thePlayer.setHotbarOffset((this.thePlayer.inventory.getHotbarOffset() + ContainerInventory.HOTBAR_SIZE) % ContainerInventory.MAIN_INVENTORY_SIZE);
                     this.hotbarSwapAnimationProgress = HOTBAR_SWAP_ANIMATION_LENGTH_TICKS;
                     this.thePlayer.inventory.changeCurrentSlot(0);
                 }
@@ -2044,13 +2045,11 @@ public class Minecraft
     }
 
     public void createAndStartWorld(final @NotNull WorldConfiguration worldConfiguration) {
-        final @NotNull LevelStorage levelStorage = this.saveFormat.getSaveHandler(worldConfiguration.getFolderName(this.saveFormat), false);
+        final @NotNull LevelStorage levelStorage = this.saveFormat.getLevelStorage(worldConfiguration.getFolderName(this.saveFormat), false);
         for (final @NotNull Dimension dimension : Dimension.getDimensionList().values()) {
             final @Nullable WorldType worldType = worldConfiguration.getWorldTypeGroup().get(dimension);
-            if (worldType != null) {
-                final @NotNull DimensionData data = new DimensionData(worldType);
-                levelStorage.saveDimensionData(dimension.id, data);
-            }
+            final @NotNull DimensionData data = new DimensionData(worldType);
+            levelStorage.saveDimensionData(dimension.id, data);
         }
 
         final @NotNull WorldClient world = new WorldClient(
@@ -2058,7 +2057,7 @@ public class Minecraft
             worldConfiguration.getFinalWorldName(),
             worldConfiguration.getFinalNumericSeed(),
             Dimension.OVERWORLD,
-            null, worldConfiguration.getStartingBiome()
+            worldConfiguration.getStartingBiome()
         );
         world.getLevelData().setCheatsEnabled(worldConfiguration.getCheatsEnabled());
         world.getLevelData().getGameRules().setValues(worldConfiguration.getGameRuleCollection());
@@ -2094,14 +2093,16 @@ public class Minecraft
             convertSaveVersion(worldSaveVersion, worldDirName);
         } else {
             I18n i18n = I18n.getInstance();
-            LevelStorage saveHandler = this.saveFormat.getSaveHandler(worldDirName, false);
-            Dimension dimension = null;
+            LevelStorage saveHandler = this.saveFormat.getLevelStorage(worldDirName, false);
             CompoundTag tag = saveHandler.getPlayerData(this.session.username, this.session.uuid);
+            final @NotNull Dimension dimension;
             if (tag != null) {
                 dimension = Dimension.getDimensionList().get(tag.getInteger("Dimension"));
+            } else {
+                dimension = Dimension.OVERWORLD;
             }
 
-            WorldClient world = new WorldClient(saveHandler, null, 0L, dimension, null, null);
+            WorldClient world = new WorldClient(saveHandler, null, 0L, dimension, null);
             this.statsCounter.add(StatList.loadWorldStat, 1);
             this.statsCounter.add(StatList.startGameStat, 1);
             changeWorld(world, i18n.translateKey("gui.loading.label.loading"));
@@ -2178,23 +2179,21 @@ public class Minecraft
         this.sndManager.stopMusic();
         if (this.currentWorld != null) {
             this.currentWorld.saveWorldIndirectly(this.loadingScreen);
-            if (this.currentWorld.saveHandler != null) {
-                IChunkLoader loader = this.currentWorld.saveHandler.getChunkLoader(this.currentWorld.dimension);
-                if (loader != null) {
-                    while (loader.isSaving()) {
-                        try {
-                            Thread.sleep(1);
-                        } catch (InterruptedException e) {
-                            throw new RuntimeException(e);
-                        }
+            IChunkLoader loader = this.currentWorld.getLevelStorage().getChunkLoader(this.currentWorld.dimension);
+            if (loader != null) {
+                while (loader.isSaving()) {
+                    try {
+                        Thread.sleep(1);
+                    } catch (InterruptedException e) {
+                        throw new RuntimeException(e);
                     }
                 }
-                this.currentWorld.getChunkProvider().unloadAllChunks();
-                this.currentWorld.onUnload();
-                this.currentWorld.close();
-                if (player != null) {
-                    this.currentWorld.saveHandler.save(player);
-                }
+            }
+            this.currentWorld.getChunkProvider().unloadAllChunks();
+            this.currentWorld.onUnload();
+            this.currentWorld.close();
+            if (player != null) {
+                this.currentWorld.getLevelStorage().save(player);
             }
         }
         this.currentWorld = world;
@@ -2281,7 +2280,7 @@ public class Minecraft
 
                     levelDataTag.putInt("version", toWorldFormat.getSaveVersion());
 
-                    LevelStorage saveHandler = toWorldFormat.getSaveHandler(worldDirName, false);
+                    LevelStorage saveHandler = toWorldFormat.getLevelStorage(worldDirName, false);
                     saveHandler.saveLevelDataRaw(levelDataTag);
 
                     startWorld(worldDirName);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index e832d4503..dfb8c090a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -69,8 +69,6 @@ public class ScreenMainMenu extends Screen {
     private int logoClickCounter = 0;
     private int indexToDraw = 0;
     private int codeProgress = 0;
-    private boolean showBuildTime = false;
-    private final String buildTimeString = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date(Version.BUILD_TIME));
 
     static {
         loadLogo();
@@ -279,11 +277,6 @@ public class ScreenMainMenu extends Screen {
                 this.logoClickCounter++;
             }
         }
-        if (my >= 2 && my <= 12) {
-            if (mx >= 2 && mx <= 40) {
-                this.showBuildTime = !this.showBuildTime;
-            }
-        }
     }
 
     @Override
@@ -320,11 +313,7 @@ public class ScreenMainMenu extends Screen {
         drawStringCenteredShadow(this.fontRenderer, this.splashText, 0, -8, 0xffff00);
         GLRenderer.popFrame();
         int versionTextColor = GameSettings.ALPHA_MENU.value || !this.mc.mainMenuBackground.isEnabled() ? 0x505050 : 0xFFFFFF;
-        if (this.showBuildTime) {
-            drawStringShadow(this.fontRenderer, this.buildTimeString, 2, 2, versionTextColor);
-        } else {
-            drawStringShadow(this.fontRenderer, "Better than Adventure! " + Minecraft.VERSION, 2, 2, versionTextColor);
-        }
+        drawStringShadow(this.fontRenderer, "Better than Adventure! " + Minecraft.VERSION, 2, 2, versionTextColor);
         String disclaimer1 = i18n.translateKey("gui.main_menu.label.disclaimer.1");
         drawStringShadow(this.fontRenderer, disclaimer1, this.width - MathHelper.ceil(this.fontRenderer.stringWidthDouble(disclaimer1)) - 2, this.height - 20, 0xffffff);
         String disclaimer2 = i18n.translateKey("gui.main_menu.label.disclaimer.2");
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
index be2276fa4..2cc84dcf1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
@@ -92,7 +92,7 @@ public class ScreenSelectWorld extends Screen {
         this.saveList = saveFormat.getSaveFileList();
         this.userTags = new HashMap<>();
         for (SaveFile file : this.saveList) {
-            LevelStorage levelStorage = saveFormat.getSaveHandler(file.getFileName(), false);
+            LevelStorage levelStorage = saveFormat.getLevelStorage(file.getFileName(), false);
             LevelData data = levelStorage.getLevelData();
             if (data != null && data.getLastPlayerUUID() != null) {
                 this.userTags.put(file, levelStorage.getPlayerData(null, data.getLastPlayerUUID()));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java
index 27c5669b9..30fb7369f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenDispenser.java
@@ -3,13 +3,13 @@ package net.minecraft.client.gui.container;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.player.inventory.menu.MenuTrap;
+import net.minecraft.core.player.inventory.menu.MenuDispenser;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 
 public class ScreenDispenser extends ScreenContainerAbstract {
 
     public ScreenDispenser(ContainerInventory inventoryplayer, TileEntityDispenser tileentitydispenser) {
-        super(new MenuTrap(inventoryplayer, tileentitydispenser));
+        super(new MenuDispenser(inventoryplayer, tileentitydispenser));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
index 799065300..3712b8a1a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
@@ -10,6 +10,7 @@ import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 
@@ -131,7 +132,7 @@ public class ScreenFlagEditor
         super.mouseClicked(mx, my, buttonNum);
 
         // Do not draw with no color selected
-        if (this.flagEntity.getItem(36 + this.selectedColor) == null) {
+        if (this.flagEntity.getItem(ContainerInventory.MAIN_INVENTORY_SIZE + this.selectedColor) == null) {
             return;
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
index 360bb0453..32c731878 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
@@ -13,6 +13,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 
 public class HudIngameDoom
     extends HudIngame {
@@ -218,7 +219,7 @@ public class HudIngameDoom
         int x = width / 2 + 76;
         int y = height - 36;
 
-        int selectedHotbar = ((this.mc.thePlayer.inventory.getHotbarOffset() + 27) % 36) / 9;
+        int selectedHotbar = ((this.mc.thePlayer.inventory.getHotbarOffset() + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE)) % ContainerInventory.MAIN_INVENTORY_SIZE) / ContainerInventory.HOTBAR_SIZE;
 
         drawTexturedModalRect(x, y + 9 * selectedHotbar, 0, 129, 6, 6);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
index 612ca2ed0..ad3d114a1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
@@ -68,7 +68,7 @@ public class HudComponentHotbar
         hud.drawGuiIcon(x + 5, y, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
 
         // Render hotbar switcher and dots
-        int selectedHotbar = ((inv.getHotbarOffset() + 27) % 36) / 9;
+        int selectedHotbar = ((inv.getHotbarOffset() + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE)) % ContainerInventory.MAIN_INVENTORY_SIZE) / ContainerInventory.HOTBAR_SIZE;
         IconCoordinate coordinate = TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selector" + selectedHotbar);
         hud.drawGuiIcon(x, y, 6, 22, coordinate);
 
@@ -76,8 +76,8 @@ public class HudComponentHotbar
         GLRenderer.enableState(State.DEPTH_TEST);
         GLRenderer.enableState(State.BLEND);
         Lighting.enableInventoryLight();
-        int lastHotbarStart = (mc.thePlayer.inventory.getHotbarOffset() + 27) % 36;
-        int nextHotbarStart = (mc.thePlayer.inventory.getHotbarOffset() + 9) % 36;
+        int lastHotbarStart = (mc.thePlayer.inventory.getHotbarOffset() + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE)) % ContainerInventory.MAIN_INVENTORY_SIZE;
+        int nextHotbarStart = (mc.thePlayer.inventory.getHotbarOffset() + ContainerInventory.HOTBAR_SIZE) % ContainerInventory.MAIN_INVENTORY_SIZE;
 
         // Render hotbars being switched if appropriate
         if (mc.hotbarSwapAnimationProgress != 0.0f) {
@@ -86,7 +86,7 @@ public class HudComponentHotbar
             if (mc.hotbarSwapAnimationProgress > 0) {
 
                 // Draw last hotbar
-                for (int itemIndex = 0; itemIndex < 9; itemIndex++) {
+                for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
                     int itemX = x + 8 + itemIndex * 20;
                     int itemY = y + 3 - 22 + (int) (22 * (mc.hotbarSwapAnimationProgress - partialTick) / HOTBAR_SWAP_ANIMATION_LENGTH_TICKS);
                     renderInventorySlot(mc, itemIndex + lastHotbarStart, itemX, itemY, partialTick);
@@ -94,14 +94,14 @@ public class HudComponentHotbar
 
                 // Render hotbar items
                 GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-                for (int itemIndex = 0; itemIndex < 9; itemIndex++) {
+                for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
                     int itemX = x + 8 + itemIndex * 20;
                     int itemY = y + 3 + (int) (22 * (mc.hotbarSwapAnimationProgress - partialTick) / HOTBAR_SWAP_ANIMATION_LENGTH_TICKS);
                     renderInventorySlot(mc, itemIndex + mc.thePlayer.inventory.getHotbarOffset(), itemX, itemY, partialTick);
                 }
             } else {
                 // Draw next hotbar
-                for (int itemIndex = 0; itemIndex < 9; itemIndex++) {
+                for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
                     int itemX = x + 8 + itemIndex * 20;
                     int itemY = y + 3 + 22 + (int) (22 * (mc.hotbarSwapAnimationProgress + partialTick) / HOTBAR_SWAP_ANIMATION_LENGTH_TICKS);
                     renderInventorySlot(mc, itemIndex + nextHotbarStart, itemX, itemY, partialTick);
@@ -109,7 +109,7 @@ public class HudComponentHotbar
 
                 // Render hotbar items
                 GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-                for (int itemIndex = 0; itemIndex < 9; itemIndex++) {
+                for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
                     int itemX = x + 8 + itemIndex * 20;
                     int itemY = y + 3 + (int) (22 * (mc.hotbarSwapAnimationProgress + partialTick) / HOTBAR_SWAP_ANIMATION_LENGTH_TICKS);
                     renderInventorySlot(mc, itemIndex + mc.thePlayer.inventory.getHotbarOffset(), itemX, itemY, partialTick);
@@ -120,7 +120,7 @@ public class HudComponentHotbar
         } else {
             // Render hotbar items
             GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-            for (int itemIndex = 0; itemIndex < 9; itemIndex++) {
+            for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
                 int itemX = x + 8 + itemIndex * 20;
                 int itemY = y + 3;
                 renderInventorySlot(mc, itemIndex + mc.thePlayer.inventory.getHotbarOffset(), itemX, itemY, partialTick);
@@ -135,7 +135,7 @@ public class HudComponentHotbar
         GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
 
         // Render selector
-        hud.drawGuiIcon((x + 4) + (inv.getCurrentSlot() % 9) * 20, y - 1, 24, 24, TextureRegistry.getTexture(mc.thePlayer.getHeldObject() == null ? "minecraft:gui/hud/hotbar_selection" : "minecraft:gui/hud/hotbar_selection_locked"));
+        hud.drawGuiIcon((x + 4) + (inv.getCurrentSlot() % ContainerInventory.HOTBAR_SIZE) * 20, y - 1, 24, 24, TextureRegistry.getTexture(mc.thePlayer.getHeldObject() == null ? "minecraft:gui/hud/hotbar_selection" : "minecraft:gui/hud/hotbar_selection_locked"));
 
         GLRenderer.pushFrame();
         GLRenderer.modelM4f().translate(0, 0, 1f);
@@ -170,7 +170,7 @@ public class HudComponentHotbar
 
         // Render hotbar items
         GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        for (int itemIndex = 0; itemIndex < 9; itemIndex++) {
+        for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
             int itemX = x + 8 + itemIndex * 20;
             int itemY = y + 3;
             renderItem(mc, PREVIEW_ITEMS[itemIndex], itemX, itemY);
